/*************************************************************
 *                 bbomberman                                *
 *  (c) 2004 by Bernhard Eder (bb-generation)                *
 *  http://bbgen.net/bomberman for updates                   *
 *  Webmaster@bbgen.net for bug reports and other stuff      *
 * --------------------------------------------------------- *
 * This program is free software; you can modify it under    *
 * the terms of the GNU General Public License as published  *
 * by the Free Software Foundation, located in LICSENSE      *
 *                                                           *
 ************************************************************/
 
#include "cl_game.h"

cl_game::cl_game(void)
{
/* SETTINGS */
//  BB_COLUMNS = 21;
//  BB_ROWS = 21;
  

  
  std::ofstream out("stderr.txt");
  std::streambuf* sbuf = std::cerr.rdbuf();
  std::cerr.rdbuf(out.rdbuf());
  frmcnt=0;
  
  std::srand(std::time(NULL));
  
  Inital = new cl_init;
  Images = new cl_images;
  Settings = new cl_settings;
  
  uifields.assign(Inital->fX,Inital->fY);
  BB_DISPLAYWIDTH = Inital->iDspWidth;
  
  display_font=TTF_OpenFont("Fixedsys500c.ttf", 16);
  
  SNPlayer();
  BuildMap();
  SDL_EnableKeyRepeat(0, 0); //160, 80
  Display = SDL_CreateRGBSurface(SDL_HWSURFACE,300,Inital->screen->h,32,0,0,0,0);
  DrawDisplay(0);
  BField = SDL_CreateRGBSurface(SDL_HWSURFACE,Inital->fX*24,Inital->fY*24,32,0,0,0,0);
  DrawBField();
  SDL_Flip(Inital->screen);
  
  bool brun=1;
  SDL_Event event;
  long begtime,curtime;
  while(brun)
  {
    begtime=std::clock()/(CLOCKS_PER_SEC/1000); //IMPORTANT! because under linux it's often microseconds
    while(SDL_PollEvent(&event))
    {
      switch(event.type)
      {
        case SDL_KEYDOWN:
          if(event.key.keysym.sym == SDLK_ESCAPE) brun=0;
          ParseKey(event.key.keysym.sym);
          break;
        case SDL_QUIT:
          brun=0;
      }
    }
//    SDL_FillRect(Inital->screen, NULL, 0);
    DrawBField();
    DrawDisplay(std::clock()/(CLOCKS_PER_SEC/1000)-begtime);
    SDL_Flip(Inital->screen);
    frmcnt++;
    curtime=std::clock()/(CLOCKS_PER_SEC/1000);
    if((curtime-begtime)>75) begtime=curtime-75;
    SDL_Delay(75 - (curtime-begtime));
//    std::cout << curtime << " " << begtime << " " << curtime - begtime <<  std::endl;
  }
  std::cerr << "Frame Counter stopped at: " << frmcnt << "." << std::endl;
  std::cerr.rdbuf(sbuf);
}

cl_game::~cl_game()
{
  SDL_FreeSurface(Display);
  SDL_FreeSurface(BField);
}

/*
unsigned int cl_game::SFBombs() //Search for bombs
{

}*/

void cl_game::ParseKey(SDLKey key)
{
  for(int i=0;i<Inital->playercount;i++) //players
  {
    if(!player[i]->Bomberman->alive) continue;
    for(int j=0;j<5;j++)
    {
      if(key==Settings->bk[i][j]) player[i]->MoveTo(j);
    }
  }
}

//0 0    1 21   2 0   3 21
//0 0    1 0    2 21  3 21

void cl_game::SNPlayer()
{
  for(int i=0;i<Inital->playercount;i++)
  {
    player[i] = new cl_player;
    player[i]->Game = this;
    player[i]->keyset = i;
    player[i]->plrnum = i;
    player[i]->SetCords();
    player[i]->name = Inital->names[i];
  }
}




void cl_game::BuildMap()
{
//uifields:
// 0 nix
// 1 kiste
// 2 kiste fest
// 
  for(unsigned int i=0;i<Inital->fY;i++)
  {
    if(i == 0 || i == Inital->fY-1) //first and last row
    {
      uifields[0][i]=uifields[1][i]=uifields[Inital->fX-1][i]=uifields[Inital->fX-2][i]=0;
      for(unsigned int k=2;k<Inital->fX-2;k++)
        uifields[k][i]=1;
    }
    else
    {
      if(i%2!=0)
      {
        for(unsigned int k=0;k<Inital->fX;k++)
        {
          if(k%2==0)
          {
            if(std::rand()%5 == 0) uifields[k][i]=0;
            else uifields[k][i]=1;
          }
          else
            uifields[k][i]=2;
        }
      }
      else
      {
        for(unsigned int k=0;k<Inital->fX;k++)
          uifields[k][i]=1;
      }
    }
    if(i == 1 || i == Inital->fY-2) //second and the one before the last row
    {
      uifields[0][i]=uifields[Inital->fX-1][i]=0;
    }
  }
}


// Action: 0down 1up 2right 3left

void cl_game::DrawBomberman(unsigned short plr, unsigned short action)
{
  SDL_Rect srcrect,bdrect;
  if(action%2 == 0) srcrect.x=0;
  else srcrect.x=25;
  if(action <= 1) srcrect.y=0;
  else srcrect.y=25;
  srcrect.h=24;
  srcrect.w=24;

  bdrect.x=24*player[plr]->Bomberman->x;
  bdrect.y=24*player[plr]->Bomberman->y;
  
  SDL_BlitSurface(Images->bomberman[plr],&srcrect,BField,&bdrect);  
}

void cl_game::DrawBomberman(unsigned short plr)
{
  SDL_Rect srcrect,bdrect;
  unsigned short action=player[plr]->lastact;
  if(action%2 == 0) srcrect.x=0;
  else srcrect.x=25;
  if(action <= 1) srcrect.y=0;
  else srcrect.y=25;
  srcrect.h=24;
  srcrect.w=24;
  bdrect.x=24*player[plr]->Bomberman->x;
  bdrect.y=24*player[plr]->Bomberman->y;
  
  SDL_BlitSurface(Images->bomberman[plr],&srcrect,BField,&bdrect);  
}


void cl_game::DrawBField()
{ 
  SDL_Rect bdrect;
  
  for(int i=0;i<Inital->fY;i++) //rows
    for(int j=0;j<Inital->fX;j++) //columns
    {
      bdrect.x = 24*j;
      bdrect.y = 24*i;
      if(uifields[j][i] == 0) SDL_BlitSurface(Images->gras,NULL,BField,&bdrect);
      else if(uifields[j][i] == 1) SDL_BlitSurface(Images->box[0],NULL,BField,&bdrect);
      else if(uifields[j][i] == 2) SDL_BlitSurface(Images->box[1],NULL,BField,&bdrect);
      if(uifields[j][i] == 3)
      {
        SDL_BlitSurface(Images->gras,NULL,BField,&bdrect);
        SDL_BlitSurface(Images->powerup[0],NULL,BField,&bdrect);
      }
      if(uifields[j][i] == 4)
      {
        SDL_BlitSurface(Images->gras,NULL,BField,&bdrect);
        SDL_BlitSurface(Images->powerup[1],NULL,BField,&bdrect);
      }
    }

  DrawBombs();
  DrawPlBombermans();
  
  SDL_Rect drect;
  drect.x = (Inital->iX-Inital->fX*24-BB_DISPLAYWIDTH)/2;
  drect.y = (Inital->iY-Inital->fY*24)/2;
  SDL_BlitSurface(BField,NULL,Inital->screen,&drect);
}

//Draw the bombs and checks if any bomb have to be "killed" >:D
void cl_game::DrawBombs()
{
  for(int i=0;i<Inital->playercount;i++)
  {
    for(int j=0;j<player[i]->bombs.size();j++)
    {
      if(player[i]->bombs[j]->Check() == 2)
      {
        player[i]->bombs[j]->Explode();
      }
      if(player[i]->bombs[j]->Check() == 3)
      {
        delete player[i]->bombs[j];
        player[i]->bombs.erase(std::remove(player[i]->bombs.begin(),player[i]->bombs.end(),player[i]->bombs[j]),player[i]->bombs.end());
      }
      SDL_Rect drect;
      drect.x=24*player[i]->bombs[j]->x;
      drect.y=24*player[i]->bombs[j]->y;
      if(player[i]->bombs[j]->Check()<2) SDL_BlitSurface(Images->bomb[player[i]->bombs[j]->Check()],NULL,BField,&drect);
    }
  }
}

void cl_game::DrawPlBombermans()
{
  for(int i=0;i<Inital->playercount;i++)
  {
    if(player[i]->Bomberman->alive && player[i]->alive) DrawBomberman(i);
  }
}

void cl_game::DrawDisplay(int frlength)
{
  FillSurface(Display,Images->texture[0]);
  SDL_Rect drect,trect;
  drect.x = Inital->screen->w - BB_DISPLAYWIDTH;
  drect.y = 0;

  trect.x = 35;
  
  SDL_Color clr = { 128,128,180, 0 };
  std::stringstream strstream;

//Player display...
  for(int i=0;i<Inital->playercount;i++)
  {
    trect.y = 30*i+8;
    strstream.str("");
    strstream << Inital->names[i];
    text_surface=TTF_RenderText_Solid(display_font,strstream.str().c_str(),clr);
    SDL_BlitSurface(text_surface,NULL,Display,&trect);
    
    SDL_Rect srcrect,bdrect;
    srcrect.x=0;
    srcrect.y=0;
    srcrect.h=24;
    srcrect.w=24;
    bdrect.x=5;
    bdrect.y=30*i+6;
    
    
    SDL_BlitSurface(Images->bomberman[i],&srcrect,Display,&bdrect);  
    if(player[i]->Bomberman->alive != 1) SDL_BlitSurface(Images->cross,NULL,Display,&bdrect);
    SDL_FreeSurface(text_surface);
    
//How many bombs & explosion force?
    if(player[i]->keyset<10)
    {
//bombs
      strstream.str("");
      strstream << player[i]->Bomberman->bombs;
      text_surface = TTF_RenderText_Solid(display_font,strstream.str().c_str(),clr);
      bdrect.x = BB_DISPLAYWIDTH - 60;
      SDL_BlitSurface(Images->bomb[0],NULL,Display,&bdrect);
      
      bdrect.x += 6;
      bdrect.y += 6;
      SDL_BlitSurface(text_surface,NULL,Display,&bdrect);
      SDL_FreeSurface(text_surface);

//explosion force
      strstream.str("");
      strstream << player[i]->Bomberman->expforce;
      text_surface = TTF_RenderText_Solid(display_font,strstream.str().c_str(),clr);
      bdrect.x = BB_DISPLAYWIDTH - 31;
      bdrect.y -= 3;
      SDL_BlitSurface(Images->explosion,NULL,Display,&bdrect);
      bdrect.y += 3;
      bdrect.x += 7;
      SDL_BlitSurface(text_surface,NULL,Display,&bdrect);
      SDL_FreeSurface(text_surface);
      
    }
    
  }
//Frame Counter..
  strstream.str("");
  strstream << "Frame length: " << frlength;
  text_surface=TTF_RenderText_Solid(display_font,strstream.str().c_str(),clr);
  trect.x = 22;
  trect.y = 30*Inital->playercount + 20;
  
  SDL_BlitSurface(text_surface,NULL,Display,&trect);
  
  SDL_FreeSurface(text_surface);

//  text_surface=TTF_RenderText_Solid(display_font,strstream.str().c_str(),clrBlack);

//  SDL_BlitSurface(text_surface,NULL,Display,NULL);
    
  
  
  SDL_BlitSurface(Display,NULL,Inital->screen,&drect);
}

void cl_game::FillSurface(SDL_Surface* screen, SDL_Surface* texture)
{
//  SDL_BlitSurface(texture, NULL, screen, NULL);
  SDL_Rect srcrect, dstrect;
  srcrect.h = texture->h;
  for(int i=0;i<=ceil(screen->h/texture->h);i++) //rows
    for(int j=0;j<=ceil(screen->w/texture->w);j++) //collumns
    {
      dstrect.x = texture->w*j;
      dstrect.y = texture->h*i;
      SDL_BlitSurface(texture,NULL,screen,&dstrect);
    }
}

bool cl_game::IsField(int x, int y)
{
  if(x < 0) return 1; 
  if(y < 0) return 1; 
  if(x >= Inital->fX) return 1; //if not in the bomberman field
  if(y >= Inital->fY) return 1;
  
  if(uifields[x][y] == 1 || uifields[x][y] == 2) return 2; //is there a box
  
  for(int i=0;i<Inital->playercount;i++)
    for(int j=0;j<player[i]->bombs.size();j++) //if there is a not exploded bomb.
      if(player[i]->bombs[j]->x == x && player[i]->bombs[j]->y == y) return 3;
  
  return 0; //everything right
}


cl_bomberman::cl_bomberman()
{
  alive=1;
  bombs=1;
  expforce=1;
}

//Move Bomberman to ... 0 left, 1 right, 2 up, 3 down
bool cl_player::MoveTo(unsigned short to)
{
  if(to == 0)
  {
    if(!Game->IsField(Bomberman->x-1,Bomberman->y))
      Bomberman->x--;
    lastact=3;
  }
  if(to == 1)
  {
    if(!Game->IsField(Bomberman->x+1,Bomberman->y))
      Bomberman->x++;
    lastact=2;
  }
  if(to == 2)
  {
    if(!Game->IsField(Bomberman->x,Bomberman->y-1))
      Bomberman->y--;
    lastact=1;
  }
  if(to == 3)
  {
    if(!Game->IsField(Bomberman->x,Bomberman->y+1))
      Bomberman->y++;
    lastact=0;
  }
  if(to == 4)
  {
    if(bombs.size() >= Bomberman->bombs) return 0;
    if(Game->IsField(Bomberman->x,Bomberman->y)) return 0;
    bombs.push_back(new cl_bomb(plrnum));
    bombs[bombs.size()-1]->x = Bomberman->x;
    bombs[bombs.size()-1]->y = Bomberman->y;
    bombs[bombs.size()-1]->frtime = Game->frmcnt;
    bombs[bombs.size()-1]->Game = Game;
    bombs[bombs.size()-1]->Bomberman = Bomberman;
  }
  if(to<=3)
    CheckPowerUps();
  return 1;
//  Game->DrawBomberman(plrnum);
}

bool cl_player::CheckPowerUps()
{
  if(Game->uifields[Bomberman->x][Bomberman->y] == 3)
  {
    Game->uifields[Bomberman->x][Bomberman->y]=0;
    Bomberman->bombs++;
    return 1;
  }
  else if(Game->uifields[Bomberman->x][Bomberman->y] == 4)
  {
    Game->uifields[Bomberman->x][Bomberman->y]=0;
    Bomberman->expforce++;
    return 1;
  }
  return 0;
}

cl_player::cl_player() //Set Normal Player
{
  Bomberman = new cl_bomberman;
  lastact=0;
  alive=1;
}

bool cl_player::SetCords()
{
  if(plrnum%2 == 0) Bomberman->y=0;
  else Bomberman->y=Game->Inital->fY-1;
  if(plrnum == 0 || plrnum == 3) Bomberman->x=0;
  else Bomberman->x=Game->Inital->fX-1;
}

//ok ramblers, let's get rambling
cl_bomb::cl_bomb(unsigned short owner)
{
  iowner=owner;
}


//Returns 0 for the first lookout for the bomb
//or 1 for the second
//2 explode!
//3 delete
unsigned int cl_bomb::Check()
{
  if(Game->frmcnt<frtime+20) return 0;
  else if(Game->frmcnt<frtime+30) return 1;
  else if(Game->frmcnt<frtime+33) return 2; // BBOOOOMM, BOOOMMM, every time you drop the bomb..
  else return 3;
}

void cl_bomb::Explode()
{
  for(int i=0;i<4;i++) Exp(i);
  ExpField(x,y,5);
//  delete this;
}

//0 left, 1 right, 2 up, 3 down
bool cl_bomb::Exp(unsigned short direction)
{
  for(int i=1;i<Bomberman->expforce+1;i++)
  {
    switch(direction)
    {
      case 0: if(!ExpField(x-i,y,direction)) return 0;
              break;
      case 1: if(!ExpField(x+i,y,direction)) return 0;
              break;
      case 2: if(!ExpField(x,y-i,direction)) return 0;
              break;
      case 3: if(!ExpField(x,y+i,direction)) return 0;
              break;
    }
  }
}

bool cl_bomb::ExpField(int x, int y,unsigned int direction)
{
  if(x<0 || y<0 || x>=Game->Inital->fX || y>=Game->Inital->fY) return 0; //not in the field
  if(Game->uifields[x][y]==2) return 0; //hard box
  
  for(int i=0;i<Game->Inital->playercount;i++)
  {
    if(Game->player[i]->Bomberman->alive==0) continue;
    if(Game->player[i]->Bomberman->x==x && Game->player[i]->Bomberman->y==y)
      Game->player[i]->Kill(iowner);  //..you kill the god your child has born
  }
  if(Game->uifields[x][y]==1)
  {
    lfield nfield;
    nfield.x = x;
    nfield.y = y;
    lockedfields.push_back(nfield);
  }
  int rnd=rand()%6;
  if(Game->uifields[x][y]==1 && !(rand()%8))
  {
    if(rand()%2)
      Game->uifields[x][y]=3;
    else
      Game->uifields[x][y]=4;
  }
  else if(Game->uifields[x][y]==1)
    Game->uifields[x][y]=0;

  for(int i=0;i<Game->Inital->playercount;i++)
    for(int j=0;j<Game->player[i]->bombs.size();j++)
      if(Game->player[i]->bombs[j]->x == x && Game->player[i]->bombs[j]->y == y 
      && Game->player[i]->bombs[j] != this) Game->player[i]->bombs[j]->frtime = frtime; //chain reaction


  SDL_Rect drect;
  drect.x=24*x;
  drect.y=24*y;
  SDL_BlitSurface(Game->Images->explosion,NULL,Game->BField,&drect); 
  
  if(IsLField(x,y))
  {
    if(direction==0 && x-1>=0 && Game->uifields[x-1][y] != 0) return 0;
    else if(direction==1 && x+1<Game->Inital->fX && Game->uifields[x+1][y] != 0) return 0;
    else if(direction==2 && y-1>=0 && Game->uifields[x][y-1] != 0) return 0;
    else if(direction==3 && y+1<Game->Inital->fY && Game->uifields[x][y+1] != 0) return 0;
  }
  return 1;
}

bool cl_bomb::IsLField(int ix,int iy)
{
  for(int i=0;i<lockedfields.size();i++)
    if(lockedfields[i].x == ix && lockedfields[i].y == iy) return 1;
  return 0;
}


void cl_player::Kill(unsigned short killplr)
{
  Bomberman->alive=0;
  std::cout << "Player " << name << " killed by Player " << Game->player[killplr]->name << std::endl;
}
