/*************************************************************
 *                 bbomberman                                *
 *  (c) 2004 by Bernhard Eder (bb-generation)                *
 *  http://bbgen.net/bomberman for updates                   *
 *  Webmaster@bbgen.net for bug reports and other stuff      *
 * --------------------------------------------------------- *
 * This program is free software; you can modify it under    *
 * the terms of the GNU General Public License as published  *
 * by the Free Software Foundation, located in LICSENSE      *
 *                                                           *
 ************************************************************/

#ifndef GAME_H
#define GAME_H

#include <iostream>
#include <fstream>
//#include <SDL_gfx/SDL_gfxPrimitives.h>
#include <SDL/SDL.h>
#include <ctime>
#include <vector>
#include <SDL/SDL_ttf.h>
#include <sstream>
#include <ctime>
#include <string>
#include "cl_init.h"
#include "cl_settings.h"

//#define BB_BFIELDHIGH 504
//#define BB_BFIELDWIDTH 504
//#define BB_DISPLAYWIDTH 275

struct lfield
{
  unsigned int x,y;
};


class cl_bomberman
{
  friend class cl_game;
  friend class cl_player;
  friend class cl_bomb;
  public:
    cl_bomberman(void);
    bool alive; //True if the bomberman is alive
  protected:
    unsigned short x;
    unsigned short y;
    unsigned short bombs;
    unsigned short expforce;
    
  private:
};

class cl_bomb
{
  friend class cl_player;
  public:
    cl_bomb(unsigned short owner);
    void Explode();
    
    unsigned short x;
    unsigned short y;
    unsigned int Check(void);
  protected:
    long frtime; //counter in which frame the bomb was set
  private:
    cl_game *Game;
    cl_bomberman *Bomberman;
    unsigned short iowner; //Player number set this bomb
    
    bool Exp(unsigned short direction);
    bool ExpField(int x,int y, unsigned int direction);
    bool IsLField(int ix,int iy);
    std::vector<lfield> lockedfields;
};

class cl_player
{
  friend class cl_game;
  friend class cl_bomb;
  public:
    cl_player(void);
  protected:
    unsigned short keyset; //>=10 net
    unsigned short plrnum;
    std::string name;
    
    bool MoveTo(unsigned short to);
    bool SetCords(void);
    cl_bomberman *Bomberman;
    std::vector<cl_bomb*> bombs;
    void Kill(unsigned short killplr); //it would be horrible if any object is allowed to kill a bomberman ;)
  private:
    bool alive; //True if the player is connected and is ingame
    unsigned short lastact;
    cl_game *Game;
    
    bool CheckPowerUps();
};


class cl_game
{
  friend class cl_player;
  friend class cl_bomb;
  public:
    cl_game(void);
    ~cl_game(void);
  protected:
    void DrawBomberman(unsigned short plr, unsigned short action);
    void DrawBomberman(unsigned short plr);
    bool IsField(int x, int y);
    cl_player *player[4];
    std::vector<std::vector<int> > uifields;
    long long frmcnt; //Frame Counter
    cl_init *Inital;
  private: 
    unsigned short BB_DISPLAYWIDTH;
  
    TTF_Font *display_font;
    SDL_Surface *text_surface;
    cl_images *Images;
    cl_settings *Settings;
    SDL_Surface *Display;
    SDL_Surface *BField;
    void ParseKey(SDLKey key);
    void FillSurface(SDL_Surface* screen, SDL_Surface* texture);
    void DrawDisplay(int frlength);
    void DrawBField(void);
    void DrawPlBombermans(void);
    void DrawBombs(void);
    void BuildMap(void);
    void SNPlayer(void);
};

#endif
